#!/bin/bash
# ~/.icewm/icewm-menu2.sh
# © Christian L'Écuyer, Gatineau (Qc), Canada, sam. 28 janv. 2017, 00:03; GPL3.
#  (Alias « musher0 » [forum Puppy].) # Rév. 2017-09-02, 2017-09-03, 2017-10-23
################ # https://opensource.org/licenses/GPL-3.0
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##########
# Objectif : construire un menu bilingue (FR, EN) pour icewm. |
# Goal : build a bilingual (EN, FR) menu for icewm.
#### set -xe
# LANG=en_CA.utf8 # To test. Otherwise it is automatic.
LC_ALL=C
SousMenu () {
	for i in `grep -H $CateG *.desktop | grep Categories | awk -F":" '{ print $1 }'`
	do IcoN="`awk -F= '$1=="Icon" { print $2 }' $i`"
		[ "$IcoN" = "" ] && IcoN="-"
		ExeC="`awk -F'=' '$1=="Exec" { print $2 }' $i`"
		if [[ ! "$ExeC" =~ "default" ]]; then
			echo -e "\tprog \"${i%.*}\" \"$IcoN\" $ExeC" >> $txtDepart
			# | awk 'NF>3 && NF<5' >> $txtDepart
		fi
	done
	if [ "`wc -c < $txtDepart`" -gt "0" ];then
		echo -e "menu $CateG - {\nseparator" >> $txtArrivee
		cat $txtDepart >> $txtArrivee
		echo -e "separator\n}\n" >> $txtArrivee
	fi; }

# Avertissement
CoLoR="bd AntiqueWhite2 -bg AntiqueWhite4 -fg white"
if [ "${LANG:0:2}" = "fr" ];then
    TXTMSG3="
Le menu d'icewm
... se met à jour ..."
else
    TXTMSG3="
The icewm menu
... is being updated ..."
fi
# ./
bcm -u /root/.icewm/icewm-inv.png -a 1 -g c:c -d 5 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='AkizaSans Bold Italic 18' color='white' gravity='north' gravity_hint='line'>$TXTMSG3</span>" &

# Création du menu
cd /usr/share/applications
txtArrivee="/root/.icewm/tmp.menu2";> $txtArrivee
for CateG in Wizard Desktop Develop Network Setup System Utility
do	txtDepart="";txtDepart="/root/.icewm/tmp.config";> $txtDepart
	SousMenu;done
LC_ALL="";RPLCT="replaceit --input=$txtArrivee"
case "${LANG:0:2}" in fr)$RPLCT Desktop "Bureau" "{menu"
	$RPLCT Develop Développement "{menu";$RPLCT Network Réseau "{menu"
	$RPLCT Setup Paramétrage "{menu";$RPLCT System Système "{menu"
	$RPLCT Utility Utilitaires "{menu";$RPLCT Wizard Assistants "{menu" ;;
esac

LC_ALL=C
txtArrivee="";txtArrivee="/root/.icewm/tmp.menu";> $txtArrivee
for CateG in Archiving Audio Business Calculate Database Document TextEditor File Fun Game Graphic Internet Multimedia Personal Video
do	txtDepart="";txtDepart="/root/.icewm/tmp.categ";> $txtDepart
	SousMenu;done
LC_ALL="";RPLCT="replaceit --input=$txtArrivee"
case "${LANG:0:2}" in fr)$RPLCT Archiving Archivage "{menu"
	$RPLCT Business Affaires "{menu";$RPLCT Personal Personnel "{menu"
	$RPLCT Calculate Calculs "{menu";$RPLCT Database BdD "{menu"
	$RPLCT Document Documents "{menu";$RPLCT File Fichiers "{menu"
	$RPLCT Fun Loisirs "{menu";$RPLCT Game Jeux "{menu"
	$RPLCT Graphic Graphiques "{menu";$RPLCT Multimedia Multimédias "{menu"
	$RPLCT TextEditor Éditeurs "{menu";$RPLCT Video Vidéo "{menu" ;;
esac
#
> ~/.icewm/menu
case "${LANG:0:2}" in fr)Apps=Applis;LiseZ="Lisez-moi" ;;
	en|*)Apps=Apps;LiseZ="ReadMe" ;;
esac
echo -e "# menu | icewm | menu # par / by musher0 # 2017/01/28\n#
menu $Apps - {\nseparator\n`cat ~/.icewm/tmp.menu`
separator\n}\n\n
menu Configs - {\n`cat ~/.icewm/tmp.menu2`
separator\n}\n\n" >> ~/.icewm/menu
if [ -d /opt/openoffice4 ];then
	BaseDir="/opt/openoffice4"
	IconDir=" /usr/share/icons/Icones-aOO-Gulfstream"

	echo -e "separator
	menu aOO /opt/openoffice4/program/logo.png {
	separator
	prog Base $IconDir/ooo-base.png $BaseDir/program/sbase
	prog Calc $IconDir/ooo-calc.png $BaseDir/program/scalc
	prog Draw $IconDir/ooo-draw.png $BaseDir/program/sdraw
	prog Impress $IconDir/ooo-impress.png $BaseDir/program/simpress
	prog WebWriter $IconDir/ooo-web.png $BaseDir/program/soffice $BaseDir/a.html
	prog Writer $IconDir/ooo-writer.png $BaseDir/program/swriter
	separator
	prog "$LiseZ" $IconDir/help-contents.png defaulthtmlviewer $BaseDir/README.html
#$BaseDir/program/soffice
	separator
}" >> ~/.icewm/menu
fi
case "${LANG:0:2}" in fr)cat ~/.icewm/menu.bas >> ~/.icewm/menu ;;
	en|*)cat ~/.icewm/menu.bottom >> ~/.icewm/menu ;;
esac
echo "### 30 ###" >> ~/.icewm/menu

rm -f /root/.icewm/tmp.*;
cp -f /root/.icewm/menu /root/.icewm/menu.bckp

#################################
## Notes -- (Français) # Le menu FR prend +/- 2,9 sec. à se construire.
#
# Ajouter à la fin de /usr/sbin/fixmenus (après la série de « which ») la ligne :
# [ "`cat /etc/windowmanager`" = "icewm" ] && /root/.icewm/icewm-menu2.sh
#
# Ajouter cette même ligne juste avant la ligne qui dit « ##w468 rox may not
# start old... » (vers la ligne 173; après la section sur lxpanel) dans /root/.xinitrc.
#
# La ligne « Exec= » des fichiers *.desktop pour Open|LibreOffice devraient utiliser
# la forme abrégée, telle que : Exec=/opt/libreoffice-5.3/program/swriter.
#
# Certaines « Categories » ont dû être généralisées pour que le présent script
# fonctionne. S.v.p. voir les exemples dans l'archive.
#
########
## Notes -- (English) # The EN menu takes +/- 2.6 sec. to build.
#
# Add at the bottom of /usr/sbin/fixmenus (after the series of "which") the line:
# [ "`cat /etc/windowmanager`" = "icewm" ] && /root/.icewm/icewm-menu2.sh
#
# Add that same line just before the line that says "##w468 rox may not start old..."
# (+/- at line 173; after the lxpanel section) in /root/.xinitrc.
#
# The "Exec=" line of the *.desktop files for Open|LibreOffice should use the short
# form of the command, such as: Exec=/opt/libreoffice-5.3/program/swriter.
#
# Certain "Categories" had to be generalized for this script to work. Please see
# the examples in the archive.
#
################################# set +xe
